#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const node_cli_toolkit_1 = require("@codemaskjs/node-cli-toolkit");
const lib = (0, node_cli_toolkit_1.getPackageJson)();
(0, node_cli_toolkit_1.program)([
    (0, node_cli_toolkit_1.version)(lib.version),
    (0, node_cli_toolkit_1.usage)('mongo'),
    (0, node_cli_toolkit_1.commands)([
        (0, node_cli_toolkit_1.command)('create-migration', {
            description: 'Creates new migration',
            next: () => {
                throw new common_1.NotImplementedException('todo: requires a create migration implementation with datasource');
            }
        }),
        (0, node_cli_toolkit_1.command)('generate-migration', {
            description: 'Generates new migration based on the current schema changes',
            next: () => {
                throw new common_1.NotImplementedException('todo: generate migration based on passed datasource');
            }
        }),
        (0, node_cli_toolkit_1.command)('synchronize', {
            description: 'Synchronizes collections validators and indexes',
            next: () => {
                throw new common_1.NotImplementedException('todo: call synchronize on collections provided by datasource');
            }
        }),
        (0, node_cli_toolkit_1.command)('run-migrations', {
            description: 'Runs migrations up or down',
            next: () => {
                throw new common_1.NotImplementedException('todo: running migration up and down provided by datasource');
            }
        })
    ])
]).catch(error => {
    console.error(error);
    process.exit(1);
});
//# sourceMappingURL=mongo.js.map