import { ClientSession, ClientSessionOptions, MongoClient, ValidateCollectionOptions } from 'mongodb';
import { MongoDocument } from './mongo';
import { DataSourceOptions, Class } from './types';
import { Collection } from './collection';
import { TransactionManager } from './transaction-manager';
export declare class DataSource {
    private readonly client;
    private readonly options;
    private readonly db;
    constructor(client: MongoClient, options: DataSourceOptions);
    getDatabaseName(): string;
    getCollection<T extends MongoDocument>(entity: Class<T>): Collection<T>;
    validate<T extends MongoDocument>(entity: Class<T>, options?: ValidateCollectionOptions): Promise<MongoDocument>;
    session(options?: ClientSessionOptions): {
        withTransaction: <T>(wrapper: (manager: TransactionManager, session: ClientSession) => T) => Promise<T>;
    };
    synchronize(): Promise<void>;
    dropDatabase(): Promise<boolean>;
    connect(): Promise<MongoClient>;
    close(force?: boolean): Promise<void>;
    static createFromOptions(options: DataSourceOptions): DataSource;
}
