"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TransactionManager = void 0;
const utils_1 = require("./utils");
const collection_1 = require("./collection");
class TransactionManager {
    db;
    options;
    constructor(db, options) {
        this.db = db;
        this.options = options;
    }
    getCollection(entity) {
        const metadata = (0, utils_1.getEntityMetadata)(entity);
        if (!metadata.collectionName) {
            throw new Error(`Only entities can have collections. Please make sure your [class ${entity.name}] is properly decorated with @Entity(collectionName: string).`);
        }
        return new collection_1.Collection(this.db, metadata, this.options);
    }
}
exports.TransactionManager = TransactionManager;
//# sourceMappingURL=transaction-manager.js.map