"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var MongodbModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MongodbModule = void 0;
const common_1 = require("@nestjs/common");
const mongodb_1 = require("mongodb");
const node_crypto_1 = require("node:crypto");
const common_2 = require("../common");
const mongodb_service_1 = require("./mongodb.service");
const mongodb_test_service_1 = require("./mongodb-test.service");
let MongodbModule = MongodbModule_1 = class MongodbModule {
    static forRoot({ global, connectionName, options = {} }) {
        const defaultOptions = (0, common_2.getDefaultDataSourceOptions)(options);
        const uri = (0, common_2.getConnectionString)(defaultOptions);
        const clientToken = (0, common_2.getClientToken)(connectionName);
        const dataSourceToken = (0, common_2.getDataSourceToken)(connectionName);
        return {
            global: global ?? true,
            module: MongodbModule_1,
            exports: [clientToken, dataSourceToken],
            providers: [
                {
                    provide: clientToken,
                    useFactory: () => new mongodb_1.MongoClient(uri, defaultOptions.clientOptions)
                },
                {
                    provide: dataSourceToken,
                    inject: [clientToken],
                    useFactory: (client) => new common_2.DataSource(client, defaultOptions)
                },
                {
                    provide: common_2.INTERNAL_DATA_SOURCE,
                    inject: [dataSourceToken],
                    useFactory: (dataSource) => dataSource
                },
                {
                    provide: (0, node_crypto_1.randomUUID)(),
                    useClass: mongodb_service_1.MongodbService
                }
            ]
        };
    }
    static forRootAsync({ global, connectionName, inject, useFactory }) {
        const clientToken = (0, common_2.getClientToken)(connectionName);
        const dataSourceToken = (0, common_2.getDataSourceToken)(connectionName);
        const dataSourceOptionsToken = (0, node_crypto_1.randomUUID)();
        return {
            global: global ?? true,
            module: MongodbModule_1,
            exports: [clientToken, dataSourceToken],
            providers: [
                {
                    provide: dataSourceOptionsToken,
                    inject,
                    useFactory
                },
                {
                    provide: clientToken,
                    inject: [dataSourceOptionsToken],
                    useFactory: (options) => {
                        const defaultOptions = (0, common_2.getDefaultDataSourceOptions)(options);
                        const uri = (0, common_2.getConnectionString)(defaultOptions);
                        return new mongodb_1.MongoClient(uri, defaultOptions.clientOptions);
                    }
                },
                {
                    provide: dataSourceToken,
                    inject: [clientToken, dataSourceOptionsToken],
                    useFactory: (client, options) => {
                        const defaultOptions = (0, common_2.getDefaultDataSourceOptions)(options);
                        return new common_2.DataSource(client, defaultOptions);
                    }
                },
                {
                    provide: common_2.INTERNAL_DATA_SOURCE,
                    inject: [dataSourceToken],
                    useFactory: (dataSource) => dataSource
                },
                {
                    provide: (0, node_crypto_1.randomUUID)(),
                    useClass: mongodb_service_1.MongodbService
                }
            ]
        };
    }
    static forTestAsync({ global, connectionName, inject, useFactory }) {
        const clientToken = (0, common_2.getClientToken)(connectionName);
        const dataSourceToken = (0, common_2.getDataSourceToken)(connectionName);
        const dataSourceOptionsToken = (0, node_crypto_1.randomUUID)();
        return {
            global: global ?? true,
            module: MongodbModule_1,
            exports: [clientToken, dataSourceToken],
            providers: [
                {
                    provide: dataSourceOptionsToken,
                    inject,
                    useFactory: async (...args) => {
                        const dataSourceOptions = await useFactory(...args);
                        return { ...dataSourceOptions, database: (0, node_crypto_1.randomUUID)() };
                    }
                },
                {
                    provide: clientToken,
                    inject: [dataSourceOptionsToken],
                    useFactory: (options) => {
                        const defaultOptions = (0, common_2.getDefaultDataSourceOptions)(options);
                        const uri = (0, common_2.getConnectionString)(defaultOptions);
                        return new mongodb_1.MongoClient(uri, defaultOptions.clientOptions);
                    }
                },
                {
                    provide: dataSourceToken,
                    inject: [clientToken, dataSourceOptionsToken],
                    useFactory: (client, options) => {
                        const defaultOptions = (0, common_2.getDefaultDataSourceOptions)(options);
                        return new common_2.DataSource(client, defaultOptions);
                    }
                },
                {
                    provide: common_2.INTERNAL_DATA_SOURCE,
                    inject: [dataSourceToken],
                    useFactory: (dataSource) => dataSource
                },
                {
                    provide: (0, node_crypto_1.randomUUID)(),
                    useClass: mongodb_test_service_1.MongodbTestService
                }
            ]
        };
    }
    static forFeature(entities, connectionName) {
        const dataSourceToken = (0, common_2.getDataSourceToken)(connectionName);
        const providers = entities.map(entity => ({
            provide: (0, common_2.getCollectionToken)(entity, connectionName),
            inject: [dataSourceToken],
            useFactory: (dataSource) => dataSource.getCollection(entity)
        }));
        return {
            module: MongodbModule_1,
            providers,
            exports: providers.map(({ provide }) => provide)
        };
    }
    static forTest() {
        return {
            module: MongodbModule_1,
            providers: [],
            exports: []
        };
    }
};
exports.MongodbModule = MongodbModule;
exports.MongodbModule = MongodbModule = MongodbModule_1 = __decorate([
    (0, common_1.Module)({})
], MongodbModule);
//# sourceMappingURL=mongodb.module.js.map