#!/usr/bin/env node

import { NotImplementedException } from '@nestjs/common'
import { command, commands, getPackageJson, program, usage, version } from '@codemaskjs/node-cli-toolkit'

const lib = getPackageJson()

program([
    version(lib.version),
    usage('mongo'),
    commands([
        command('create-migration', {
            description: 'Creates new migration',
            next: () => {
                throw new NotImplementedException('todo: requires a create migration implementation with datasource')
            }
        }),
        command('generate-migration', {
            description: 'Generates new migration based on the current schema changes',
            next: () => {
                throw new NotImplementedException('todo: generate migration based on passed datasource')
            }
        }),
        command('synchronize', {
            description: 'Synchronizes collections validators and indexes',
            next: () => {
                throw new NotImplementedException('todo: call synchronize on collections provided by datasource')
            }
        }),
        command('run-migrations', {
            description: 'Runs migrations up or down',
            next: () => {
                throw new NotImplementedException('todo: running migration up and down provided by datasource')
            }
        })
    ])
]).catch(error => {
    // eslint-disable-next-line no-console
    console.error(error)
    process.exit(1)
})
