import { EntityOptions, Metadata, ENTITY_WATERMARK, EntityMetadata, ENTITY_METADATA, Class } from 'lib/common'

/**
 * Describe entities that are stored under the collection name.
 *
 * @param collectionName
 * @param entityOptions
 * @returns
 */
export const Entity =
    (collectionName: string, entityOptions: EntityOptions = {}) =>
    (entity: object) => {
        Metadata.define(entity, ENTITY_WATERMARK, true)
        Metadata.mergeDeep<EntityMetadata>(entity, ENTITY_METADATA, {
            entity: entity as Class,
            collectionName,
            entityOptions,
            entityColumns: []
        })
    }
