import { EntityOptions, Metadata, NESTED_ENTITY_WATERMARK, EntityMetadata, ENTITY_METADATA } from 'lib/common'

/**
 * Describe entities that are being nested of other entities.
 *
 * @param entityOptions
 * @returns
 */
export const NestedEntity =
    (entityOptions: EntityOptions = {}) =>
    (constructor: object) => {
        Metadata.define(constructor, NESTED_ENTITY_WATERMARK, true)
        Metadata.mergeDeep<EntityMetadata>(constructor, ENTITY_METADATA, {
            collectionName: null,
            entityOptions,
            entityColumns: []
        })
    }
