import { Inject, Injectable } from '@nestjs/common'
import { INTERNAL_DATA_SOURCE, DataSource } from 'lib/common'
import { MongodbService } from './mongodb.service'

@Injectable()
export class MongodbTestService extends MongodbService {
    constructor(
        @Inject(INTERNAL_DATA_SOURCE)
         readonly dataSource: DataSource
    ) {
        super(dataSource)
    }

    async onModuleDestroy() {
        await this.dataSource.dropDatabase()
        await super.onModuleDestroy()
    }
}
