import { Inject, Injectable, OnModuleInit } from '@nestjs/common'
import { INTERNAL_DATA_SOURCE, DataSource } from 'lib/common'

@Injectable()
export class MongodbService implements OnModuleInit {
    constructor(
        @Inject(INTERNAL_DATA_SOURCE)
        protected readonly dataSource: DataSource
    ) {}

    async onModuleInit() {
        await this.dataSource.connect()
        await this.dataSource.synchronize()
    }

    async onModuleDestroy() {
        await this.dataSource.close()
    }
}
